<?php

namespace AisFssp;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Attachments' => '\\AisFssp\\StructType\\Attachments',
            'AttachmentFileVersion' => '\\AisFssp\\StructType\\AttachmentFileVersion',
            'AttachmentFileInfo' => '\\AisFssp\\StructType\\AttachmentFileInfo',
            'FileInfo' => '\\AisFssp\\StructType\\FileInfo',
            'SignatureType' => '\\AisFssp\\StructType\\SignatureType',
            'SignatureValueType' => '\\AisFssp\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\AisFssp\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\AisFssp\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\AisFssp\\StructType\\SignatureMethodType',
            'ReferenceType' => '\\AisFssp\\StructType\\ReferenceType',
            'TransformsType' => '\\AisFssp\\StructType\\TransformsType',
            'TransformType' => '\\AisFssp\\StructType\\TransformType',
            'DigestMethodType' => '\\AisFssp\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\AisFssp\\StructType\\KeyInfoType',
            'KeyValueType' => '\\AisFssp\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\AisFssp\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\AisFssp\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\AisFssp\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\AisFssp\\StructType\\PGPDataType',
            'SPKIDataType' => '\\AisFssp\\StructType\\SPKIDataType',
            'ObjectType' => '\\AisFssp\\StructType\\ObjectType',
            'ManifestType' => '\\AisFssp\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\AisFssp\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\AisFssp\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\AisFssp\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\AisFssp\\StructType\\RSAKeyValueType',
            'DXBox' => '\\AisFssp\\StructType\\DXBox',
            'MessageEx' => '\\AisFssp\\StructType\\MessageEx',
            'RedAddress' => '\\AisFssp\\StructType\\RedAddress',
            'Direction' => '\\AisFssp\\StructType\\Direction',
            'DocumentRef' => '\\AisFssp\\StructType\\DocumentRef',
            'DXBlock' => '\\AisFssp\\StructType\\DXBlock',
            'DXControl' => '\\AisFssp\\StructType\\DXControl',
            'Pack' => '\\AisFssp\\StructType\\Pack',
            'File' => '\\AisFssp\\StructType\\File',
            'Document' => '\\AisFssp\\StructType\\Document',
            'DXPack' => '\\AisFssp\\StructType\\DXPack',
            'Documents' => '\\AisFssp\\StructType\\Documents',
            'Envelopes' => '\\AisFssp\\StructType\\Envelopes',
            'DXReceipt' => '\\AisFssp\\StructType\\DXReceipt',
            'DocNoteCollection' => '\\AisFssp\\StructType\\DocNoteCollection',
            'DocNote' => '\\AisFssp\\StructType\\DocNote',
            'AttachmentFileNote' => '\\AisFssp\\StructType\\AttachmentFileNote',
            'DocumentContainer' => '\\AisFssp\\StructType\\DocumentContainer',
            'Envelope' => '\\AisFssp\\StructType\\Envelope',
            'EnvelopeFileInfo' => '\\AisFssp\\StructType\\EnvelopeFileInfo',
            'ProtocolFileInfo' => '\\AisFssp\\StructType\\ProtocolFileInfo',
            'HttpFileInfo' => '\\AisFssp\\StructType\\HttpFileInfo',
            'FileBlockInfo' => '\\AisFssp\\StructType\\FileBlockInfo',
            'FileData' => '\\AisFssp\\StructType\\FileData',
            'FileDataBlock' => '\\AisFssp\\StructType\\FileDataBlock',
            'DXFileRequest' => '\\AisFssp\\StructType\\DXFileRequest',
            'DXFileData' => '\\AisFssp\\StructType\\DXFileData',
            'DXFileReceipt' => '\\AisFssp\\StructType\\DXFileReceipt',
            'DXSysInfoRequest' => '\\AisFssp\\StructType\\DXSysInfoRequest',
            'DXSystemInfo' => '\\AisFssp\\StructType\\DXSystemInfo',
            'OrganizationEx' => '\\AisFssp\\StructType\\OrganizationEx',
            'DepartmentEx' => '\\AisFssp\\StructType\\DepartmentEx',
            'DXLookupTableRequest' => '\\AisFssp\\StructType\\DXLookupTableRequest',
            'DXLookupTableData' => '\\AisFssp\\StructType\\DXLookupTableData',
            'LookupTableData' => '\\AisFssp\\StructType\\LookupTableData',
            'DocumentAttrs' => '\\AisFssp\\StructType\\DocumentAttrs',
            'DocumentAttr' => '\\AisFssp\\StructType\\DocumentAttr',
            'DXEnvBlock' => '\\AisFssp\\StructType\\DXEnvBlock',
            'DXPutDocument' => '\\AisFssp\\StructType\\DXPutDocument',
            'DXGetDocumentResult' => '\\AisFssp\\StructType\\DXGetDocumentResult',
            'DXNotifyDocument' => '\\AisFssp\\StructType\\DXNotifyDocument',
            'DXDocumentResult' => '\\AisFssp\\StructType\\DXDocumentResult',
            'FioType' => '\\AisFssp\\StructType\\FioType',
            'AddressType' => '\\AisFssp\\StructType\\AddressType',
            'ContragentDatumType' => '\\AisFssp\\StructType\\ContragentDatumType',
            'AttachmentType' => '\\AisFssp\\StructType\\AttachmentType',
            'EMailAttachmentType' => '\\AisFssp\\StructType\\EMailAttachmentType',
            'ShareType' => '\\AisFssp\\StructType\\ShareType',
            'SenderContragentType' => '\\AisFssp\\StructType\\SenderContragentType',
            'SenderSPIType' => '\\AisFssp\\StructType\\SenderSPIType',
            'DocRefType' => '\\AisFssp\\StructType\\DocRefType',
            'EmbeddedDocumentType' => '\\AisFssp\\StructType\\EmbeddedDocumentType',
            'PrintFormDocumentType' => '\\AisFssp\\StructType\\PrintFormDocumentType',
            'EMailHeaderType' => '\\AisFssp\\StructType\\EMailHeaderType',
            'IP' => '\\AisFssp\\StructType\\IP',
            'IPExt' => '\\AisFssp\\StructType\\IPExt',
            'Data' => '\\AisFssp\\StructType\\Data',
            'InformationType' => '\\AisFssp\\StructType\\InformationType',
            'IdentificationDataType' => '\\AisFssp\\StructType\\IdentificationDataType',
            'AddressDataType' => '\\AisFssp\\StructType\\AddressDataType',
            'TelephoneDataType' => '\\AisFssp\\StructType\\TelephoneDataType',
            'TransportDataType' => '\\AisFssp\\StructType\\TransportDataType',
            'ShipDatumType' => '\\AisFssp\\StructType\\ShipDatumType',
            'ShipEngineType' => '\\AisFssp\\StructType\\ShipEngineType',
            'HijackingType' => '\\AisFssp\\StructType\\HijackingType',
            'MachineDatumType' => '\\AisFssp\\StructType\\MachineDatumType',
            'SvedRabDataType' => '\\AisFssp\\StructType\\SvedRabDataType',
            'ManagementDataType' => '\\AisFssp\\StructType\\ManagementDataType',
            'SvedDoxodDataType' => '\\AisFssp\\StructType\\SvedDoxodDataType',
            'DebtorStateDataType' => '\\AisFssp\\StructType\\DebtorStateDataType',
            'AccountDatumType' => '\\AisFssp\\StructType\\AccountDatumType',
            'AvailabilityAccDataType' => '\\AisFssp\\StructType\\AvailabilityAccDataType',
            'AvailabilityAccExtDataType' => '\\AisFssp\\StructType\\AvailabilityAccExtDataType',
            'ArrestRecoveryAmountDataType' => '\\AisFssp\\StructType\\ArrestRecoveryAmountDataType',
            'AccountEncumbranceDatumType' => '\\AisFssp\\StructType\\AccountEncumbranceDatumType',
            'AvailabilityAccDepoDataType' => '\\AisFssp\\StructType\\AvailabilityAccDepoDataType',
            'AccountTransactionDatumType' => '\\AisFssp\\StructType\\AccountTransactionDatumType',
            'DepositBoxDatumType' => '\\AisFssp\\StructType\\DepositBoxDatumType',
            'RealtyRegistryExtractType' => '\\AisFssp\\StructType\\RealtyRegistryExtractType',
            'SvedNedvDataType' => '\\AisFssp\\StructType\\SvedNedvDataType',
            'PropertyObligationDatumType' => '\\AisFssp\\StructType\\PropertyObligationDatumType',
            'SvedNedvObjectType' => '\\AisFssp\\StructType\\SvedNedvObjectType',
            'SvedNedvAreaType' => '\\AisFssp\\StructType\\SvedNedvAreaType',
            'SvedNedvRightType' => '\\AisFssp\\StructType\\SvedNedvRightType',
            'SvedNedvEncumbranceType' => '\\AisFssp\\StructType\\SvedNedvEncumbranceType',
            'SvedNedvShareHoldingType' => '\\AisFssp\\StructType\\SvedNedvShareHoldingType',
            'ObjectDataType' => '\\AisFssp\\StructType\\ObjectDataType',
            'KKTDataType' => '\\AisFssp\\StructType\\KKTDataType',
            'AccountingDataType' => '\\AisFssp\\StructType\\AccountingDataType',
            'AccountType' => '\\AisFssp\\StructType\\AccountType',
            'TicketDatumType' => '\\AisFssp\\StructType\\TicketDatumType',
            'PersonDatumType' => '\\AisFssp\\StructType\\PersonDatumType',
            'OrganizationDatumType' => '\\AisFssp\\StructType\\OrganizationDatumType',
            'RegOrganDatumType' => '\\AisFssp\\StructType\\RegOrganDatumType',
            'PublicEnityType' => '\\AisFssp\\StructType\\PublicEnityType',
            'CompanyDatumType' => '\\AisFssp\\StructType\\CompanyDatumType',
            'CompanyExtDatumType' => '\\AisFssp\\StructType\\CompanyExtDatumType',
            'OkvedDetailType' => '\\AisFssp\\StructType\\OkvedDetailType',
            'FounderCompanyDatumType' => '\\AisFssp\\StructType\\FounderCompanyDatumType',
            'ForgnFndrCompanyDatumType' => '\\AisFssp\\StructType\\ForgnFndrCompanyDatumType',
            'FounderPersonDatumType' => '\\AisFssp\\StructType\\FounderPersonDatumType',
            'CompanyManagementDatumType' => '\\AisFssp\\StructType\\CompanyManagementDatumType',
            'LicenseDatumType' => '\\AisFssp\\StructType\\LicenseDatumType',
            'LicenseActivityType' => '\\AisFssp\\StructType\\LicenseActivityType',
            'SubdivisionDatumType' => '\\AisFssp\\StructType\\SubdivisionDatumType',
            'EgrulEgripDatumType' => '\\AisFssp\\StructType\\EgrulEgripDatumType',
            'RegistrationDatumType' => '\\AisFssp\\StructType\\RegistrationDatumType',
            'CompanyAddressDatumType' => '\\AisFssp\\StructType\\CompanyAddressDatumType',
            'AccountExtDatumType' => '\\AisFssp\\StructType\\AccountExtDatumType',
            'DocumentDatumType' => '\\AisFssp\\StructType\\DocumentDatumType',
            'SoleEntrepreneurOldRegDatumType' => '\\AisFssp\\StructType\\SoleEntrepreneurOldRegDatumType',
            'SoleEntrepreneurDatumType' => '\\AisFssp\\StructType\\SoleEntrepreneurDatumType',
            'PaymentDatumType' => '\\AisFssp\\StructType\\PaymentDatumType',
            'CountDatumType' => '\\AisFssp\\StructType\\CountDatumType',
            'UnaccountedForDatumType' => '\\AisFssp\\StructType\\UnaccountedForDatumType',
            'DeathDatumType' => '\\AisFssp\\StructType\\DeathDatumType',
            'FishDatumType' => '\\AisFssp\\StructType\\FishDatumType',
            'FishQuotaContractDatumType' => '\\AisFssp\\StructType\\FishQuotaContractDatumType',
            'FishQuotaCurYearDatumType' => '\\AisFssp\\StructType\\FishQuotaCurYearDatumType',
            'FishNonquotaContractDatumType' => '\\AisFssp\\StructType\\FishNonquotaContractDatumType',
            'TransactionDatumType' => '\\AisFssp\\StructType\\TransactionDatumType',
            'UnstructuredDatumType' => '\\AisFssp\\StructType\\UnstructuredDatumType',
            'TransactionSideType' => '\\AisFssp\\StructType\\TransactionSideType',
            'SalaryWithheldDatumType' => '\\AisFssp\\StructType\\SalaryWithheldDatumType',
            'WithheldDetailType' => '\\AisFssp\\StructType\\WithheldDetailType',
            'CashLetterDatumType' => '\\AisFssp\\StructType\\CashLetterDatumType',
            'ValidationDatumType' => '\\AisFssp\\StructType\\ValidationDatumType',
            'ValidationStepDetailType' => '\\AisFssp\\StructType\\ValidationStepDetailType',
            'UnemployedPersonRegistrationDatumType' => '\\AisFssp\\StructType\\UnemployedPersonRegistrationDatumType',
            'UnemployedPersonCaseDatumType' => '\\AisFssp\\StructType\\UnemployedPersonCaseDatumType',
            'SeniorityPeriodDatumType' => '\\AisFssp\\StructType\\SeniorityPeriodDatumType',
            'GoodsDatumType' => '\\AisFssp\\StructType\\GoodsDatumType',
            'WeaponDatumType' => '\\AisFssp\\StructType\\WeaponDatumType',
            'SentencedPersonImprisonmentType' => '\\AisFssp\\StructType\\SentencedPersonImprisonmentType',
            'SentencedPersonNoImprisonmentType' => '\\AisFssp\\StructType\\SentencedPersonNoImprisonmentType',
            'BKIDatumType' => '\\AisFssp\\StructType\\BKIDatumType',
            'LookupTableQuery' => '\\AisFssp\\StructType\\LookupTableQuery',
            'OspProperty' => '\\AisFssp\\StructType\\OspProperty',
            'OspDetail' => '\\AisFssp\\StructType\\OspDetail',
            'CurrencyProperty' => '\\AisFssp\\StructType\\CurrencyProperty',
            'IdDocTypeProperty' => '\\AisFssp\\StructType\\IdDocTypeProperty',
            'PievFormatVersion' => '\\AisFssp\\StructType\\PievFormatVersion',
            'ReferenceDataType' => '\\AisFssp\\StructType\\ReferenceDataType',
            'DataBlock' => '\\AisFssp\\StructType\\DataBlock',
            'Query' => '\\AisFssp\\StructType\\Query',
            'Answer' => '\\AisFssp\\StructType\\Answer',
            'AccountQuery' => '\\AisFssp\\StructType\\AccountQuery',
            'AccountAnswer' => '\\AisFssp\\StructType\\AccountAnswer',
            'SalaryWithheldQuery' => '\\AisFssp\\StructType\\SalaryWithheldQuery',
            'SalaryWithheldAnswer' => '\\AisFssp\\StructType\\SalaryWithheldAnswer',
            'Restrictn' => '\\AisFssp\\StructType\\Restrictn',
            'Report' => '\\AisFssp\\StructType\\Report',
            'DebtorNewAccountNotice' => '\\AisFssp\\StructType\\DebtorNewAccountNotice',
            'ExtDoc' => '\\AisFssp\\StructType\\ExtDoc',
            'PaymentProperties' => '\\AisFssp\\StructType\\PaymentProperties',
            'SequestrationType' => '\\AisFssp\\StructType\\SequestrationType',
            'ReportPropertyType' => '\\AisFssp\\StructType\\ReportPropertyType',
            'ProcDoc' => '\\AisFssp\\StructType\\ProcDoc',
            'ExtDebtFix' => '\\AisFssp\\StructType\\ExtDebtFix',
            'RecallDoc' => '\\AisFssp\\StructType\\RecallDoc',
            'DebtRequest' => '\\AisFssp\\StructType\\DebtRequest',
            'Debt' => '\\AisFssp\\StructType\\Debt',
            'ExtPayments' => '\\AisFssp\\StructType\\ExtPayments',
            'PayProperties' => '\\AisFssp\\StructType\\PayProperties',
            'ExtPayment' => '\\AisFssp\\StructType\\ExtPayment',
            'OspRequest' => '\\AisFssp\\StructType\\OspRequest',
            'OspProperties' => '\\AisFssp\\StructType\\OspProperties',
            'BankruptDoc' => '\\AisFssp\\StructType\\BankruptDoc',
            'DebtorPropertyChange' => '\\AisFssp\\StructType\\DebtorPropertyChange',
            'ArrestFourthStagePropertyType' => '\\AisFssp\\StructType\\ArrestFourthStagePropertyType',
            'DebtorIpNotify' => '\\AisFssp\\StructType\\DebtorIpNotify',
            'NoticeReadinessSaleSeizedProperty' => '\\AisFssp\\StructType\\NoticeReadinessSaleSeizedProperty',
            'NoticeSaleSeizedProperty' => '\\AisFssp\\StructType\\NoticeSaleSeizedProperty',
            'CertificateDeliveryAcceptance' => '\\AisFssp\\StructType\\CertificateDeliveryAcceptance',
            'ReportExecutionSale' => '\\AisFssp\\StructType\\ReportExecutionSale',
            'IPSideQuery' => '\\AisFssp\\StructType\\IPSideQuery',
            'IPSideAnswer' => '\\AisFssp\\StructType\\IPSideAnswer',
            'IPDocInfoType' => '\\AisFssp\\StructType\\IPDocInfoType',
            'IPAccountingType' => '\\AisFssp\\StructType\\IPAccountingType',
            'RequestByDatum' => '\\AisFssp\\StructType\\RequestByDatum',
            'ExitRestrictionActRequest' => '\\AisFssp\\StructType\\ExitRestrictionActRequest',
            'ExitRestrictionActInfo' => '\\AisFssp\\StructType\\ExitRestrictionActInfo',
            'RestrictionActRequest' => '\\AisFssp\\StructType\\RestrictionActRequest',
            'RestrictionActInfo' => '\\AisFssp\\StructType\\RestrictionActInfo',
            'ActInfoType' => '\\AisFssp\\StructType\\ActInfoType',
            'IPDataRequest' => '\\AisFssp\\StructType\\IPDataRequest',
            'InvestigationDataInfo' => '\\AisFssp\\StructType\\InvestigationDataInfo',
            'IPDataInfo' => '\\AisFssp\\StructType\\IPDataInfo',
            'RecoveredAmountRequest' => '\\AisFssp\\StructType\\RecoveredAmountRequest',
            'RecoveredAmountAnswer' => '\\AisFssp\\StructType\\RecoveredAmountAnswer',
            'RecoveringIpInfoType' => '\\AisFssp\\StructType\\RecoveringIpInfoType',
            'RecoveredAmountType' => '\\AisFssp\\StructType\\RecoveredAmountType',
            'InvestigationRegistryQuery' => '\\AisFssp\\StructType\\InvestigationRegistryQuery',
            'InvestigationRegistryInfo' => '\\AisFssp\\StructType\\InvestigationRegistryInfo',
            'InvestigationRegistryDetail' => '\\AisFssp\\StructType\\InvestigationRegistryDetail',
            'ArrestRegistryQuery' => '\\AisFssp\\StructType\\ArrestRegistryQuery',
            'ArrestRegistryInfo' => '\\AisFssp\\StructType\\ArrestRegistryInfo',
            'ArrestRegistryDetail' => '\\AisFssp\\StructType\\ArrestRegistryDetail',
            'CrimeRegistryQuery' => '\\AisFssp\\StructType\\CrimeRegistryQuery',
            'CrimeRegistryInfo' => '\\AisFssp\\StructType\\CrimeRegistryInfo',
            'CrimeRegistryDetail' => '\\AisFssp\\StructType\\CrimeRegistryDetail',
            'CaRequest' => '\\AisFssp\\StructType\\CaRequest',
            'CaAnswer' => '\\AisFssp\\StructType\\CaAnswer',
            'InvestigationRegistry' => '\\AisFssp\\StructType\\InvestigationRegistry',
            'InvestigationData' => '\\AisFssp\\StructType\\InvestigationData',
            'PenaltyChargesRegistry' => '\\AisFssp\\StructType\\PenaltyChargesRegistry',
            'PenaltyChargesData' => '\\AisFssp\\StructType\\PenaltyChargesData',
            'RestrictionRegistry' => '\\AisFssp\\StructType\\RestrictionRegistry',
            'UINRegistry' => '\\AisFssp\\StructType\\UINRegistry',
            'OspInputRegistry' => '\\AisFssp\\StructType\\OspInputRegistry',
            'ReqAppResult' => '\\AisFssp\\StructType\\ReqAppResult',
            'AnswerAppResult' => '\\AisFssp\\StructType\\AnswerAppResult',
            'CitizenQuestionsRequest' => '\\AisFssp\\StructType\\CitizenQuestionsRequest',
            'CitizenQuestionsResult' => '\\AisFssp\\StructType\\CitizenQuestionsResult',
            'CitizenQuestionsResData' => '\\AisFssp\\StructType\\CitizenQuestionsResData',
            'BKIRequest' => '\\AisFssp\\StructType\\BKIRequest',
            'BKIResponse' => '\\AisFssp\\StructType\\BKIResponse',
            'DocumentNote' => '\\AisFssp\\StructType\\DocumentNote',
            'PaymentNotification' => '\\AisFssp\\StructType\\PaymentNotification',
            'PaymentNotificationInfo' => '\\AisFssp\\StructType\\PaymentNotificationInfo',
            'DebtorIPListRequestType' => '\\AisFssp\\StructType\\DebtorIPListRequestType',
            'DebtorIPListResponseType' => '\\AisFssp\\StructType\\DebtorIPListResponseType',
            'ClaimerIPListRequestType' => '\\AisFssp\\StructType\\ClaimerIPListRequestType',
            'ClaimerIPListResponseType' => '\\AisFssp\\StructType\\ClaimerIPListResponseType',
            'BriefIPInformationType' => '\\AisFssp\\StructType\\BriefIPInformationType',
            'IPSideRequestType' => '\\AisFssp\\StructType\\IPSideRequestType',
            'IPSideRequestExistenceType' => '\\AisFssp\\StructType\\IPSideRequestExistenceType',
            'IPSideRequestCourseIDType' => '\\AisFssp\\StructType\\IPSideRequestCourseIDType',
            'IPSideRequestCourseIPType' => '\\AisFssp\\StructType\\IPSideRequestCourseIPType',
            'IPReqAppResponseType' => '\\AisFssp\\StructType\\IPReqAppResponseType',
            'IPReqAppResultRequestType' => '\\AisFssp\\StructType\\IPReqAppResultRequestType',
            'IPReqAppResultReponseType' => '\\AisFssp\\StructType\\IPReqAppResultReponseType',
            'EApplicationType' => '\\AisFssp\\StructType\\EApplicationType',
            'EApplicationResultType' => '\\AisFssp\\StructType\\EApplicationResultType',
            'IPBriefInfoRequestType' => '\\AisFssp\\StructType\\IPBriefInfoRequestType',
            'IPBriefInfoResponseType' => '\\AisFssp\\StructType\\IPBriefInfoResponseType',
            'MailStateTrackingRequest' => '\\AisFssp\\StructType\\MailStateTrackingRequest',
            'BarcodeList' => '\\AisFssp\\StructType\\BarcodeList',
            'MailState' => '\\AisFssp\\StructType\\MailState',
            'InformationDocument' => '\\AisFssp\\StructType\\InformationDocument',
            'DocumentStatusSMEV3' => '\\AisFssp\\StructType\\DocumentStatusSMEV3',
            'IncomingForcedExecDocument' => '\\AisFssp\\StructType\\IncomingForcedExecDocument',
            'IncomingForcedExecDocumentBrief' => '\\AisFssp\\StructType\\IncomingForcedExecDocumentBrief',
            'OutgoingForcedExecDocument' => '\\AisFssp\\StructType\\OutgoingForcedExecDocument',
            'OutgoingArbitraryDocument' => '\\AisFssp\\StructType\\OutgoingArbitraryDocument',
            'ForcedExecDocumentRequest' => '\\AisFssp\\StructType\\ForcedExecDocumentRequest',
            'IncomingEMailMessage' => '\\AisFssp\\StructType\\IncomingEMailMessage',
            'OutgoingEMailMessage' => '\\AisFssp\\StructType\\OutgoingEMailMessage',
            'RegistryFileRequest' => '\\AisFssp\\StructType\\RegistryFileRequest',
            'RegistryFileResponse' => '\\AisFssp\\StructType\\RegistryFileResponse',
            'EQSyncRegistryRequest' => '\\AisFssp\\StructType\\EQSyncRegistryRequest',
            'EQSyncRegistryResponse' => '\\AisFssp\\StructType\\EQSyncRegistryResponse',
            'EQAppointmentDocument' => '\\AisFssp\\StructType\\EQAppointmentDocument',
            'EQApplicant' => '\\AisFssp\\StructType\\EQApplicant',
            'EQAppointmentDocResult' => '\\AisFssp\\StructType\\EQAppointmentDocResult',
            'EQNotifyAppointment' => '\\AisFssp\\StructType\\EQNotifyAppointment',
            'EQNotifyAppResult' => '\\AisFssp\\StructType\\EQNotifyAppResult',
            'ReferenceInfoRequest' => '\\AisFssp\\StructType\\ReferenceInfoRequest',
            'ReferenceInfo' => '\\AisFssp\\StructType\\ReferenceInfo',
            'MessageCollection' => '\\AisFssp\\StructType\\MessageCollection',
            'Message' => '\\AisFssp\\StructType\\Message',
            'MessageResultCollection' => '\\AisFssp\\StructType\\MessageResultCollection',
            'MessageResult' => '\\AisFssp\\StructType\\MessageResult',
            'Request' => '\\AisFssp\\StructType\\Request',
            'Response' => '\\AisFssp\\StructType\\Response',
            'SyncRq' => '\\AisFssp\\StructType\\SyncRq',
            'SyncRs' => '\\AisFssp\\StructType\\SyncRs',
            'InquiryMessage' => '\\AisFssp\\StructType\\InquiryMessage',
            'AnswerMessage' => '\\AisFssp\\StructType\\AnswerMessage',
            'GetMessagesRq' => '\\AisFssp\\StructType\\GetMessagesRq',
            'GetMessagesRs' => '\\AisFssp\\StructType\\GetMessagesRs',
            'NotifyMessagesRq' => '\\AisFssp\\StructType\\NotifyMessagesRq',
            'NotifyMessagesRs' => '\\AisFssp\\StructType\\NotifyMessagesRs',
            'PutMessagesRq' => '\\AisFssp\\StructType\\PutMessagesRq',
            'PutMessagesRs' => '\\AisFssp\\StructType\\PutMessagesRs',
            'TouchRq' => '\\AisFssp\\StructType\\TouchRq',
            'TouchRs' => '\\AisFssp\\StructType\\TouchRs',
            'GetLookupTablesRq' => '\\AisFssp\\StructType\\GetLookupTablesRq',
            'GetLookupTablesRs' => '\\AisFssp\\StructType\\GetLookupTablesRs',
            'AutoProcessRq' => '\\AisFssp\\StructType\\AutoProcessRq',
            'AutoProcessRs' => '\\AisFssp\\StructType\\AutoProcessRs',
            'Error' => '\\AisFssp\\StructType\\Error',
            'DxMessageType' => '\\AisFssp\\StructType\\DxMessageType',
            'DxNotifyDocumentType' => '\\AisFssp\\StructType\\DxNotifyDocumentType',
        );
    }
}
