<?php

namespace AisFssp\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Dx ServiceType
 * @subpackage Services
 */
class Dx extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Dx
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \AisFssp\StructType\DXBox $dXBox
     * @return \AisFssp\StructType\DXBox|bool
     */
    public function Dx(\AisFssp\StructType\DXBox $dXBox)
    {
        try {
            $this->setResult(self::getSoapClient()->Dx($dXBox));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \AisFssp\StructType\DXBox
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
