<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArrestRegistryQuery StructType
 * Meta informations extracted from the WSDL
 * - documentation: Запрос в реестр арестованного имущество отправленного на реализацию
 * - type: tns:ArrestRegistryQuery
 * @subpackage Structs
 */
class ArrestRegistryQuery extends RequestByDatum
{
    /**
     * The Debtor
     * Meta informations extracted from the WSDL
     * - documentation: Должник | Сведения о должнике
     * @var \AisFssp\StructType\ContragentDatumType
     */
    public $Debtor;
    /**
     * Constructor method for ArrestRegistryQuery
     * @uses ArrestRegistryQuery::setDebtor()
     * @param \AisFssp\StructType\ContragentDatumType $debtor
     */
    public function __construct(\AisFssp\StructType\ContragentDatumType $debtor = null)
    {
        $this
            ->setDebtor($debtor);
    }
    /**
     * Get Debtor value
     * @return \AisFssp\StructType\ContragentDatumType|null
     */
    public function getDebtor()
    {
        return $this->Debtor;
    }
    /**
     * Set Debtor value
     * @param \AisFssp\StructType\ContragentDatumType $debtor
     * @return \AisFssp\StructType\ArrestRegistryQuery
     */
    public function setDebtor(\AisFssp\StructType\ContragentDatumType $debtor = null)
    {
        $this->Debtor = $debtor;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\ArrestRegistryQuery
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
