<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Attachments StructType
 * Meta informations extracted from the WSDL
 * - documentation: Данные о вложенных файлах
 * @subpackage Structs
 */
class Attachments extends AbstractStructBase
{
    /**
     * The AttachmentFileInfo
     * Meta informations extracted from the WSDL
     * - documentation: Данные о вложении
     * - maxOccurs: unbounded
     * @var \AisFssp\StructType\AttachmentFileInfo[]
     */
    public $AttachmentFileInfo;
    /**
     * Constructor method for Attachments
     * @uses Attachments::setAttachmentFileInfo()
     * @param \AisFssp\StructType\AttachmentFileInfo[] $attachmentFileInfo
     */
    public function __construct(array $attachmentFileInfo = array())
    {
        $this
            ->setAttachmentFileInfo($attachmentFileInfo);
    }
    /**
     * Get AttachmentFileInfo value
     * @return \AisFssp\StructType\AttachmentFileInfo[]|null
     */
    public function getAttachmentFileInfo()
    {
        return $this->AttachmentFileInfo;
    }
    /**
     * Set AttachmentFileInfo value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\AttachmentFileInfo[] $attachmentFileInfo
     * @return \AisFssp\StructType\Attachments
     */
    public function setAttachmentFileInfo(array $attachmentFileInfo = array())
    {
        foreach ($attachmentFileInfo as $attachmentsAttachmentFileInfoItem) {
            // validation for constraint: itemType
            if (!$attachmentsAttachmentFileInfoItem instanceof \AisFssp\StructType\AttachmentFileInfo) {
                throw new \InvalidArgumentException(sprintf('The AttachmentFileInfo property can only contain items of \AisFssp\StructType\AttachmentFileInfo, "%s" given', is_object($attachmentsAttachmentFileInfoItem) ? get_class($attachmentsAttachmentFileInfoItem) : gettype($attachmentsAttachmentFileInfoItem)), __LINE__);
            }
        }
        $this->AttachmentFileInfo = $attachmentFileInfo;
        return $this;
    }
    /**
     * Add item to AttachmentFileInfo value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\AttachmentFileInfo $item
     * @return \AisFssp\StructType\Attachments
     */
    public function addToAttachmentFileInfo(\AisFssp\StructType\AttachmentFileInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AisFssp\StructType\AttachmentFileInfo) {
            throw new \InvalidArgumentException(sprintf('The AttachmentFileInfo property can only contain items of \AisFssp\StructType\AttachmentFileInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AttachmentFileInfo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\Attachments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
