<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AutoProcessRs StructType
 * Meta informations extracted from the WSDL
 * - documentation: Результат автоматической обработки документов
 * @subpackage Structs
 */
class AutoProcessRs extends SyncRs
{
    /**
     * The ipDataInfo
     * Meta informations extracted from the WSDL
     * - documentation: Информация об исполнительных производствах
     * @var \AisFssp\StructType\IPDataInfo
     */
    public $ipDataInfo;
    /**
     * The debtorIPListResponse
     * Meta informations extracted from the WSDL
     * - documentation: Список исполнительных производств
     * @var \AisFssp\StructType\DebtorIPListResponseType
     */
    public $debtorIPListResponse;
    /**
     * Constructor method for AutoProcessRs
     * @uses AutoProcessRs::setIpDataInfo()
     * @uses AutoProcessRs::setDebtorIPListResponse()
     * @param \AisFssp\StructType\IPDataInfo $ipDataInfo
     * @param \AisFssp\StructType\DebtorIPListResponseType $debtorIPListResponse
     */
    public function __construct(\AisFssp\StructType\IPDataInfo $ipDataInfo = null, \AisFssp\StructType\DebtorIPListResponseType $debtorIPListResponse = null)
    {
        $this
            ->setIpDataInfo($ipDataInfo)
            ->setDebtorIPListResponse($debtorIPListResponse);
    }
    /**
     * Get ipDataInfo value
     * @return \AisFssp\StructType\IPDataInfo|null
     */
    public function getIpDataInfo()
    {
        return $this->ipDataInfo;
    }
    /**
     * Set ipDataInfo value
     * @param \AisFssp\StructType\IPDataInfo $ipDataInfo
     * @return \AisFssp\StructType\AutoProcessRs
     */
    public function setIpDataInfo(\AisFssp\StructType\IPDataInfo $ipDataInfo = null)
    {
        $this->ipDataInfo = $ipDataInfo;
        return $this;
    }
    /**
     * Get debtorIPListResponse value
     * @return \AisFssp\StructType\DebtorIPListResponseType|null
     */
    public function getDebtorIPListResponse()
    {
        return $this->debtorIPListResponse;
    }
    /**
     * Set debtorIPListResponse value
     * @param \AisFssp\StructType\DebtorIPListResponseType $debtorIPListResponse
     * @return \AisFssp\StructType\AutoProcessRs
     */
    public function setDebtorIPListResponse(\AisFssp\StructType\DebtorIPListResponseType $debtorIPListResponse = null)
    {
        $this->debtorIPListResponse = $debtorIPListResponse;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\AutoProcessRs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
