<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentAttrs StructType
 * Meta informations extracted from the WSDL
 * - documentation: Дополнительные атрибуты документа
 * - type: tns:DocumentAttrs
 * @subpackage Structs
 */
class DocumentAttrs extends AbstractStructBase
{
    /**
     * The DocumentAttr
     * Meta informations extracted from the WSDL
     * - documentation: Атрибут документа
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AisFssp\StructType\DocumentAttr[]
     */
    public $DocumentAttr;
    /**
     * Constructor method for DocumentAttrs
     * @uses DocumentAttrs::setDocumentAttr()
     * @param \AisFssp\StructType\DocumentAttr[] $documentAttr
     */
    public function __construct(array $documentAttr = array())
    {
        $this
            ->setDocumentAttr($documentAttr);
    }
    /**
     * Get DocumentAttr value
     * @return \AisFssp\StructType\DocumentAttr[]|null
     */
    public function getDocumentAttr()
    {
        return $this->DocumentAttr;
    }
    /**
     * Set DocumentAttr value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\DocumentAttr[] $documentAttr
     * @return \AisFssp\StructType\DocumentAttrs
     */
    public function setDocumentAttr(array $documentAttr = array())
    {
        foreach ($documentAttr as $documentAttrsDocumentAttrItem) {
            // validation for constraint: itemType
            if (!$documentAttrsDocumentAttrItem instanceof \AisFssp\StructType\DocumentAttr) {
                throw new \InvalidArgumentException(sprintf('The DocumentAttr property can only contain items of \AisFssp\StructType\DocumentAttr, "%s" given', is_object($documentAttrsDocumentAttrItem) ? get_class($documentAttrsDocumentAttrItem) : gettype($documentAttrsDocumentAttrItem)), __LINE__);
            }
        }
        $this->DocumentAttr = $documentAttr;
        return $this;
    }
    /**
     * Add item to DocumentAttr value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\DocumentAttr $item
     * @return \AisFssp\StructType\DocumentAttrs
     */
    public function addToDocumentAttr(\AisFssp\StructType\DocumentAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AisFssp\StructType\DocumentAttr) {
            throw new \InvalidArgumentException(sprintf('The DocumentAttr property can only contain items of \AisFssp\StructType\DocumentAttr, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentAttr[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\DocumentAttrs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
