<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetLookupTablesRs StructType
 * Meta informations extracted from the WSDL
 * - documentation: Данные справочника
 * @subpackage Structs
 */
class GetLookupTablesRs extends SyncRs
{
    /**
     * The lookupTableData
     * Meta informations extracted from the WSDL
     * - documentation: Данные справочников
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AisFssp\StructType\LookupTableData[]
     */
    public $lookupTableData;
    /**
     * Constructor method for GetLookupTablesRs
     * @uses GetLookupTablesRs::setLookupTableData()
     * @param \AisFssp\StructType\LookupTableData[] $lookupTableData
     */
    public function __construct(array $lookupTableData = array())
    {
        $this
            ->setLookupTableData($lookupTableData);
    }
    /**
     * Get lookupTableData value
     * @return \AisFssp\StructType\LookupTableData[]|null
     */
    public function getLookupTableData()
    {
        return $this->lookupTableData;
    }
    /**
     * Set lookupTableData value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\LookupTableData[] $lookupTableData
     * @return \AisFssp\StructType\GetLookupTablesRs
     */
    public function setLookupTableData(array $lookupTableData = array())
    {
        foreach ($lookupTableData as $getLookupTablesRsLookupTableDataItem) {
            // validation for constraint: itemType
            if (!$getLookupTablesRsLookupTableDataItem instanceof \AisFssp\StructType\LookupTableData) {
                throw new \InvalidArgumentException(sprintf('The lookupTableData property can only contain items of \AisFssp\StructType\LookupTableData, "%s" given', is_object($getLookupTablesRsLookupTableDataItem) ? get_class($getLookupTablesRsLookupTableDataItem) : gettype($getLookupTablesRsLookupTableDataItem)), __LINE__);
            }
        }
        $this->lookupTableData = $lookupTableData;
        return $this;
    }
    /**
     * Add item to lookupTableData value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\LookupTableData $item
     * @return \AisFssp\StructType\GetLookupTablesRs
     */
    public function addToLookupTableData(\AisFssp\StructType\LookupTableData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AisFssp\StructType\LookupTableData) {
            throw new \InvalidArgumentException(sprintf('The lookupTableData property can only contain items of \AisFssp\StructType\LookupTableData, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->lookupTableData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\GetLookupTablesRs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
