<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IPReqAppResponseType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Документ IPReqAppResponseType «Подтверждение регистрации запроса или заявления в ОСП» | ЭП
 * - type: tns:IPReqAppResponseType
 * @subpackage Structs
 */
class IPReqAppResponseType extends AbstractStructBase
{
    /**
     * The internalKey
     * Meta informations extracted from the WSDL
     * - documentation: Ключ подтверждения | Ключ объекта, присвоенний информационной системой ФССП РФ при создании объекта или при получении объекта
     * от контрагента
     * - maxInclusive: 9223372036854775807
     * - minInclusive: -9223372036854775808
     * @var int
     */
    public $internalKey;
    /**
     * The externalReqKey
     * Meta informations extracted from the WSDL
     * - documentation: Ключ запроса или заявления ЕПГУ | Идентификатор объекта, присвоенный объекту АИС внешнего контрагентом (ФНС, ПФР и прочие).
     * Данный идентификатор должен быть уникальным для типа идентифицируемого документа в пространстве обмена данными с конкретным внешним
     * контрагентом.
     * - maxLength: 60
     * - minLength: 1
     * @var string
     */
    public $externalReqKey;
    /**
     * The internalReqKey
     * Meta informations extracted from the WSDL
     * - documentation: Ключ запроса или заявления АИС ФССП России | Ключ запроса, зарегистрированного в системе для последующего получения ответа на
     * него | Ключ объекта, присвоенний информационной системой ФССП РФ при создании объекта или при получении объекта от контрагента
     * - maxInclusive: 9223372036854775807
     * - minInclusive: -9223372036854775808
     * @var int
     */
    public $internalReqKey;
    /**
     * The Signature
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: ds:Signature
     * @var \AisFssp\StructType\SignatureType[]
     */
    public $Signature;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - documentation: Атрибут документа | Идентификатор объекта | Атрибут документа
     * - maxLength: 60
     * - minLength: 1
     * @var string
     */
    public $Id;
    /**
     * Constructor method for IPReqAppResponseType
     * @uses IPReqAppResponseType::setInternalKey()
     * @uses IPReqAppResponseType::setExternalReqKey()
     * @uses IPReqAppResponseType::setInternalReqKey()
     * @uses IPReqAppResponseType::setSignature()
     * @uses IPReqAppResponseType::setId()
     * @param int $internalKey
     * @param string $externalReqKey
     * @param int $internalReqKey
     * @param \AisFssp\StructType\SignatureType[] $signature
     * @param string $id
     */
    public function __construct($internalKey = null, $externalReqKey = null, $internalReqKey = null, array $signature = array(), $id = null)
    {
        $this
            ->setInternalKey($internalKey)
            ->setExternalReqKey($externalReqKey)
            ->setInternalReqKey($internalReqKey)
            ->setSignature($signature)
            ->setId($id);
    }
    /**
     * Get internalKey value
     * @return int|null
     */
    public function getInternalKey()
    {
        return $this->internalKey;
    }
    /**
     * Set internalKey value
     * @param int $internalKey
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function setInternalKey($internalKey = null)
    {
        // validation for constraint: maxInclusive
        if ($internalKey > 9223372036854775807) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be inferior or equal to 9223372036854775807, "%s" given', $internalKey), __LINE__);
        }
        // validation for constraint: minInclusive
        if ($internalKey < -9223372036854775808) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be superior or equal to -9223372036854775808, "%s" given', $internalKey), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($internalKey) && !is_numeric($internalKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($internalKey)), __LINE__);
        }
        $this->internalKey = $internalKey;
        return $this;
    }
    /**
     * Get externalReqKey value
     * @return string|null
     */
    public function getExternalReqKey()
    {
        return $this->externalReqKey;
    }
    /**
     * Set externalReqKey value
     * @param string $externalReqKey
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function setExternalReqKey($externalReqKey = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($externalReqKey) && strlen($externalReqKey) > 60) || (is_array($externalReqKey) && count($externalReqKey) > 60)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 60 element(s) or a scalar of 60 character(s) at most, "%d" length given', is_scalar($externalReqKey) ? strlen($externalReqKey) : count($externalReqKey)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($externalReqKey) && strlen($externalReqKey) < 1) || (is_array($externalReqKey) && count($externalReqKey) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($externalReqKey) && !is_string($externalReqKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($externalReqKey)), __LINE__);
        }
        $this->externalReqKey = $externalReqKey;
        return $this;
    }
    /**
     * Get internalReqKey value
     * @return int|null
     */
    public function getInternalReqKey()
    {
        return $this->internalReqKey;
    }
    /**
     * Set internalReqKey value
     * @param int $internalReqKey
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function setInternalReqKey($internalReqKey = null)
    {
        // validation for constraint: maxInclusive
        if ($internalReqKey > 9223372036854775807) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be inferior or equal to 9223372036854775807, "%s" given', $internalReqKey), __LINE__);
        }
        // validation for constraint: minInclusive
        if ($internalReqKey < -9223372036854775808) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must be superior or equal to -9223372036854775808, "%s" given', $internalReqKey), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($internalReqKey) && !is_numeric($internalReqKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($internalReqKey)), __LINE__);
        }
        $this->internalReqKey = $internalReqKey;
        return $this;
    }
    /**
     * Get Signature value
     * @return \AisFssp\StructType\SignatureType[]|null
     */
    public function getSignature()
    {
        return $this->Signature;
    }
    /**
     * Set Signature value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\SignatureType[] $signature
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function setSignature(array $signature = array())
    {
        foreach ($signature as $iPReqAppResponseTypeSignatureItem) {
            // validation for constraint: itemType
            if (!$iPReqAppResponseTypeSignatureItem instanceof \AisFssp\StructType\SignatureType) {
                throw new \InvalidArgumentException(sprintf('The Signature property can only contain items of \AisFssp\StructType\SignatureType, "%s" given', is_object($iPReqAppResponseTypeSignatureItem) ? get_class($iPReqAppResponseTypeSignatureItem) : gettype($iPReqAppResponseTypeSignatureItem)), __LINE__);
            }
        }
        $this->Signature = $signature;
        return $this;
    }
    /**
     * Add item to Signature value
     * @throws \InvalidArgumentException
     * @param \AisFssp\StructType\SignatureType $item
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function addToSignature(\AisFssp\StructType\SignatureType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AisFssp\StructType\SignatureType) {
            throw new \InvalidArgumentException(sprintf('The Signature property can only contain items of \AisFssp\StructType\SignatureType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Signature[] = $item;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public function setId($id = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($id) && strlen($id) > 60) || (is_array($id) && count($id) > 60)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 60 element(s) or a scalar of 60 character(s) at most, "%d" length given', is_scalar($id) ? strlen($id) : count($id)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($id) && strlen($id) < 1) || (is_array($id) && count($id) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\IPReqAppResponseType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
