<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NotifyMessagesRs StructType
 * Meta informations extracted from the WSDL
 * - documentation: Уведомление о результатах обработки уведомления о результате приема пакетов документов (не требует обработки)
 * @subpackage Structs
 */
class NotifyMessagesRs extends Response
{
    /**
     * The notifyResults
     * Meta informations extracted from the WSDL
     * - documentation: Результат обработки уведомлений
     * - minOccurs: 0
     * @var \AisFssp\StructType\MessageResultCollection
     */
    public $notifyResults;
    /**
     * The messageResults
     * Meta informations extracted from the WSDL
     * - documentation: Результат обработки сообщений | Не используется в текущей версии сервиса
     * - minOccurs: 0
     * @var \AisFssp\StructType\MessageResultCollection
     */
    public $messageResults;
    /**
     * Constructor method for NotifyMessagesRs
     * @uses NotifyMessagesRs::setNotifyResults()
     * @uses NotifyMessagesRs::setMessageResults()
     * @param \AisFssp\StructType\MessageResultCollection $notifyResults
     * @param \AisFssp\StructType\MessageResultCollection $messageResults
     */
    public function __construct(\AisFssp\StructType\MessageResultCollection $notifyResults = null, \AisFssp\StructType\MessageResultCollection $messageResults = null)
    {
        $this
            ->setNotifyResults($notifyResults)
            ->setMessageResults($messageResults);
    }
    /**
     * Get notifyResults value
     * @return \AisFssp\StructType\MessageResultCollection|null
     */
    public function getNotifyResults()
    {
        return $this->notifyResults;
    }
    /**
     * Set notifyResults value
     * @param \AisFssp\StructType\MessageResultCollection $notifyResults
     * @return \AisFssp\StructType\NotifyMessagesRs
     */
    public function setNotifyResults(\AisFssp\StructType\MessageResultCollection $notifyResults = null)
    {
        $this->notifyResults = $notifyResults;
        return $this;
    }
    /**
     * Get messageResults value
     * @return \AisFssp\StructType\MessageResultCollection|null
     */
    public function getMessageResults()
    {
        return $this->messageResults;
    }
    /**
     * Set messageResults value
     * @param \AisFssp\StructType\MessageResultCollection $messageResults
     * @return \AisFssp\StructType\NotifyMessagesRs
     */
    public function setMessageResults(\AisFssp\StructType\MessageResultCollection $messageResults = null)
    {
        $this->messageResults = $messageResults;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\NotifyMessagesRs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
