<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObjectDataType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Тип сведений ObjectDataType "Объекты учета"
 * @subpackage Structs
 */
class ObjectDataType extends InformationType
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - documentation: Наименование объекта учета (у которых не заполнена дата снятия с учета) | Строка длиной от 1 до 300 символов
     * - maxLength: 300
     * - minLength: 1
     * @var string
     */
    public $Name;
    /**
     * The Location
     * Meta informations extracted from the WSDL
     * - documentation: Адрес (место нахождения) объекта учета | Адрес в формате «Код страны» + «запятая» + «Адрес в формате 9 запятых по КЛАДР» или (в
     * случае отсутствия кода страны) в произвольном формате | Строка длиной от 1 до 300 символов
     * - minOccurs: 0
     * - maxLength: 300
     * - minLength: 1
     * @var string
     */
    public $Location;
    /**
     * Constructor method for ObjectDataType
     * @uses ObjectDataType::setName()
     * @uses ObjectDataType::setLocation()
     * @param string $name
     * @param string $location
     */
    public function __construct($name = null, $location = null)
    {
        $this
            ->setName($name)
            ->setLocation($location);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \AisFssp\StructType\ObjectDataType
     */
    public function setName($name = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($name) && strlen($name) > 300) || (is_array($name) && count($name) > 300)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 300 element(s) or a scalar of 300 character(s) at most, "%d" length given', is_scalar($name) ? strlen($name) : count($name)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($name) && strlen($name) < 1) || (is_array($name) && count($name) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Location value
     * @return string|null
     */
    public function getLocation()
    {
        return $this->Location;
    }
    /**
     * Set Location value
     * @param string $location
     * @return \AisFssp\StructType\ObjectDataType
     */
    public function setLocation($location = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($location) && strlen($location) > 300) || (is_array($location) && count($location) > 300)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 300 element(s) or a scalar of 300 character(s) at most, "%d" length given', is_scalar($location) ? strlen($location) : count($location)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($location) && strlen($location) < 1) || (is_array($location) && count($location) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($location) && !is_string($location)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($location)), __LINE__);
        }
        $this->Location = $location;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\ObjectDataType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
