<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegOrganDatumType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Сведения о регистрирующей организации
 * @subpackage Structs
 */
class RegOrganDatumType extends OrganizationDatumType
{
    /**
     * The organizationId
     * Meta informations extracted from the WSDL
     * - documentation: Код организации | Идентификатор записи в БД ФНС (для ЕГРЮЛ/ЕГРИП)
     * - minOccurs: 0
     * - totalDigits: 15
     * @var int
     */
    public $organizationId;
    /**
     * Constructor method for RegOrganDatumType
     * @uses RegOrganDatumType::setOrganizationId()
     * @param int $organizationId
     */
    public function __construct($organizationId = null)
    {
        $this
            ->setOrganizationId($organizationId);
    }
    /**
     * Get organizationId value
     * @return int|null
     */
    public function getOrganizationId()
    {
        return $this->organizationId;
    }
    /**
     * Set organizationId value
     * @param int $organizationId
     * @return \AisFssp\StructType\RegOrganDatumType
     */
    public function setOrganizationId($organizationId = null)
    {
        // validation for constraint: totalDigits
        if (is_float($organizationId) && strlen(str_replace(array(' ', '.', ',', '-', '+'), '', $organizationId)) !== 15) {
            throw new \InvalidArgumentException(sprintf('Invalid value, the value must at most contain 15 digits, "%d" given', strlen(substr($organizationId, strpos($organizationId, '.')))), __LINE__);
        }
        // validation for constraint: int
        if (!is_null($organizationId) && !is_numeric($organizationId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($organizationId)), __LINE__);
        }
        $this->organizationId = $organizationId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\RegOrganDatumType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
