<?php

namespace AisFssp\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnstructuredDatumType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Неструктурированные сведения о должнике
 * @subpackage Structs
 */
class UnstructuredDatumType extends InformationType
{
    /**
     * The textDatums
     * Meta informations extracted from the WSDL
     * - documentation: Сведения | Массив произвольных данных (текстовый)
     * @var string
     */
    public $textDatums;
    /**
     * The departmentName
     * Meta informations extracted from the WSDL
     * - documentation: Наименование подразделения | Строка длиной от 1 до 1000 символов
     * - maxLength: 1000
     * - minLength: 1
     * @var string
     */
    public $departmentName;
    /**
     * The regionCode
     * Meta informations extracted from the WSDL
     * - documentation: Код региона | Код региона по КЛАДР
     * - length: 2
     * - pattern: [0-9]{2}
     * @var string
     */
    public $regionCode;
    /**
     * Constructor method for UnstructuredDatumType
     * @uses UnstructuredDatumType::setTextDatums()
     * @uses UnstructuredDatumType::setDepartmentName()
     * @uses UnstructuredDatumType::setRegionCode()
     * @param string $textDatums
     * @param string $departmentName
     * @param string $regionCode
     */
    public function __construct($textDatums = null, $departmentName = null, $regionCode = null)
    {
        $this
            ->setTextDatums($textDatums)
            ->setDepartmentName($departmentName)
            ->setRegionCode($regionCode);
    }
    /**
     * Get textDatums value
     * @return string|null
     */
    public function getTextDatums()
    {
        return $this->textDatums;
    }
    /**
     * Set textDatums value
     * @param string $textDatums
     * @return \AisFssp\StructType\UnstructuredDatumType
     */
    public function setTextDatums($textDatums = null)
    {
        // validation for constraint: string
        if (!is_null($textDatums) && !is_string($textDatums)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($textDatums)), __LINE__);
        }
        $this->textDatums = $textDatums;
        return $this;
    }
    /**
     * Get departmentName value
     * @return string|null
     */
    public function getDepartmentName()
    {
        return $this->departmentName;
    }
    /**
     * Set departmentName value
     * @param string $departmentName
     * @return \AisFssp\StructType\UnstructuredDatumType
     */
    public function setDepartmentName($departmentName = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($departmentName) && strlen($departmentName) > 1000) || (is_array($departmentName) && count($departmentName) > 1000)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 1000 element(s) or a scalar of 1000 character(s) at most, "%d" length given', is_scalar($departmentName) ? strlen($departmentName) : count($departmentName)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($departmentName) && strlen($departmentName) < 1) || (is_array($departmentName) && count($departmentName) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($departmentName) && !is_string($departmentName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($departmentName)), __LINE__);
        }
        $this->departmentName = $departmentName;
        return $this;
    }
    /**
     * Get regionCode value
     * @return string|null
     */
    public function getRegionCode()
    {
        return $this->regionCode;
    }
    /**
     * Set regionCode value
     * @param string $regionCode
     * @return \AisFssp\StructType\UnstructuredDatumType
     */
    public function setRegionCode($regionCode = null)
    {
        // validation for constraint: length
        if ((is_scalar($regionCode) && strlen($regionCode) !== 2) || (is_array($regionCode) && count($regionCode) !== 2)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s)', __LINE__);
        }
        // validation for constraint: pattern
        if (is_scalar($regionCode) && !preg_match('/[0-9]{2}/', $regionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "[0-9]{2}", "%s" given', var_export($regionCode, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($regionCode) && !is_string($regionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regionCode)), __LINE__);
        }
        $this->regionCode = $regionCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \AisFssp\StructType\UnstructuredDatumType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
